// picalcDlg.h : header file
//

#if !defined(AFX_PICALCDLG_H__7D6E8585_EACA_4EF6_B309_4456D6D070D4__INCLUDED_)
#define AFX_PICALCDLG_H__7D6E8585_EACA_4EF6_B309_4456D6D070D4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CPicalcDlg dialog

class CPicalcDlg : public CDialog
{
// Construction
public:
	CPicalcDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CPicalcDlg)
	enum { IDD = IDD_PICALC_DIALOG };
	CProgressCtrl	m_Progress;
	long	m_NumDigits;
	CString	m_Results;
	CString	m_Status;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPicalcDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CPicalcDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnGo();
	afx_msg void OnTimer(UINT nIDEvent);
	virtual void OnCancel();
	afx_msg void OnAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	static UINT CalculationThread(LPVOID param);
	void EnableControls(BOOL Enable);

	enum ThreadState 
	{
		STATE_INACTIVE,
		STATE_CALCULATING,
		STATE_FORMATTING_RESULT,
		STATE_FINISHED,
		STATE_FAILED,
	};

	volatile ThreadState m_State;

	DWORD m_StartTime;

	// for gauging the speed of the computer
	DWORD m_TimeToDoInitialCalculation;
	long m_NumDigitsInInitialCalculation;
	double m_ApproxTimeInSecs;

	UINT m_TimerId;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PICALCDLG_H__7D6E8585_EACA_4EF6_B309_4456D6D070D4__INCLUDED_)
